/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// OnCallPositiveAnswerMachineDetection - Invoked when an answering machine is detected on an outbound call.    OnCallPositiveFaxDetection - Invoked when a fax machine is detected on an outbound call.    OnCallRingbackToneDetection - Invoked when a ringback tone is detected on an outbound call.    OnCallPositiveVoiceDetection - Invoked when a human voice is detected on an outbound call.
    /// </summary>
    [DataContract]
        public partial class CallProgressSubscriptions :  IEquatable<CallProgressSubscriptions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CallProgressSubscriptions" /> class.
        /// </summary>
        /// <param name="onCallPositiveAnswerMachineDetection">onCallPositiveAnswerMachineDetection.</param>
        /// <param name="onCallPositiveFaxDetection">onCallPositiveFaxDetection.</param>
        /// <param name="onCallRingbackToneDetection">onCallRingbackToneDetection.</param>
        /// <param name="onCallPositiveVoiceDetection">onCallPositiveVoiceDetection.</param>
        public CallProgressSubscriptions(string onCallPositiveAnswerMachineDetection = default(string), string onCallPositiveFaxDetection = default(string), string onCallRingbackToneDetection = default(string), string onCallPositiveVoiceDetection = default(string))
        {
            this.OnCallPositiveAnswerMachineDetection = onCallPositiveAnswerMachineDetection;
            this.OnCallPositiveFaxDetection = onCallPositiveFaxDetection;
            this.OnCallRingbackToneDetection = onCallRingbackToneDetection;
            this.OnCallPositiveVoiceDetection = onCallPositiveVoiceDetection;
        }
        
        /// <summary>
        /// Gets or Sets OnCallPositiveAnswerMachineDetection
        /// </summary>
        [DataMember(Name="onCallPositiveAnswerMachineDetection", EmitDefaultValue=false)]
        public string OnCallPositiveAnswerMachineDetection { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPositiveFaxDetection
        /// </summary>
        [DataMember(Name="onCallPositiveFaxDetection", EmitDefaultValue=false)]
        public string OnCallPositiveFaxDetection { get; set; }

        /// <summary>
        /// Gets or Sets OnCallRingbackToneDetection
        /// </summary>
        [DataMember(Name="onCallRingbackToneDetection", EmitDefaultValue=false)]
        public string OnCallRingbackToneDetection { get; set; }

        /// <summary>
        /// Gets or Sets OnCallPositiveVoiceDetection
        /// </summary>
        [DataMember(Name="onCallPositiveVoiceDetection", EmitDefaultValue=false)]
        public string OnCallPositiveVoiceDetection { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CallProgressSubscriptions {\n");
            sb.Append("  OnCallPositiveAnswerMachineDetection: ").Append(OnCallPositiveAnswerMachineDetection).Append("\n");
            sb.Append("  OnCallPositiveFaxDetection: ").Append(OnCallPositiveFaxDetection).Append("\n");
            sb.Append("  OnCallRingbackToneDetection: ").Append(OnCallRingbackToneDetection).Append("\n");
            sb.Append("  OnCallPositiveVoiceDetection: ").Append(OnCallPositiveVoiceDetection).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CallProgressSubscriptions);
        }

        /// <summary>
        /// Returns true if CallProgressSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of CallProgressSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CallProgressSubscriptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnCallPositiveAnswerMachineDetection == input.OnCallPositiveAnswerMachineDetection ||
                    (this.OnCallPositiveAnswerMachineDetection != null &&
                    this.OnCallPositiveAnswerMachineDetection.Equals(input.OnCallPositiveAnswerMachineDetection))
                ) && 
                (
                    this.OnCallPositiveFaxDetection == input.OnCallPositiveFaxDetection ||
                    (this.OnCallPositiveFaxDetection != null &&
                    this.OnCallPositiveFaxDetection.Equals(input.OnCallPositiveFaxDetection))
                ) && 
                (
                    this.OnCallRingbackToneDetection == input.OnCallRingbackToneDetection ||
                    (this.OnCallRingbackToneDetection != null &&
                    this.OnCallRingbackToneDetection.Equals(input.OnCallRingbackToneDetection))
                ) && 
                (
                    this.OnCallPositiveVoiceDetection == input.OnCallPositiveVoiceDetection ||
                    (this.OnCallPositiveVoiceDetection != null &&
                    this.OnCallPositiveVoiceDetection.Equals(input.OnCallPositiveVoiceDetection))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnCallPositiveAnswerMachineDetection != null)
                    hashCode = hashCode * 59 + this.OnCallPositiveAnswerMachineDetection.GetHashCode();
                if (this.OnCallPositiveFaxDetection != null)
                    hashCode = hashCode * 59 + this.OnCallPositiveFaxDetection.GetHashCode();
                if (this.OnCallRingbackToneDetection != null)
                    hashCode = hashCode * 59 + this.OnCallRingbackToneDetection.GetHashCode();
                if (this.OnCallPositiveVoiceDetection != null)
                    hashCode = hashCode * 59 + this.OnCallPositiveVoiceDetection.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
